#line 1 "C:/Evil Genius/MikroProC/P18F4685/X10 Color Touch Pen Cal/X10_Color_Touch_main.c"
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10_color_touch_objects.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TButton Button1;
extern TButton Button2;
extern TButton Button3;
extern TButton Button4;
extern TButton Button5;
extern TButton Button6;
extern TButton Button7;
extern TButton Button8;
extern TButton Button17;
extern TButton Button18;
extern TButton Button19;
extern TLabel Label5;
extern TLabel Label6;
extern TButton * const code Screen1_Buttons[11];
extern TLabel * const code Screen1_Labels[4];


extern TScreen Screen2;
extern TLabel Label3;
extern TLabel Label4;
extern TButton Button9;
extern TButton Button10;
extern TButton Button11;
extern TButton Button12;
extern TButton Button13;
extern TButton Button14;
extern TButton Button15;
extern TButton Button16;
extern TButton Button24;
extern TButton Button25;
extern TButton Button22;
extern TLabel Label7;
extern TLabel Label8;
extern TButton * const code Screen2_Buttons[11];
extern TLabel * const code Screen2_Labels[4];





void Button1Down();
void Button2Down();
void Button3Down();
void Button4Down();
void Button5Down();
void Button6Down();
void Button7Down();
void Button8Down();
void Button17Down();
void Button18Down();
void Button19Down();
void Button9Down();
void Button10Down();
void Button11Down();
void Button12Down();
void Button13Down();
void Button14Down();
void Button15Down();
void Button16Down();
void Button24Down();
void Button25Down();
void Button22Down();




extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button17_Caption[];
extern char Button18_Caption[];
extern char Button19_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Button16_Caption[];
extern char Button24_Caption[];
extern char Button25_Caption[];
extern char Button22_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/eprom.h"
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10_color_touch_resources.h"
const code char Tahoma18x18_Bold[];
const code char Tahoma16x19_Regular[];
const code char Tahoma19x19_Bold[];
#line 2 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/eprom.h"
unsigned int x_min, y_min, x_max, y_max;
char txtrci[6];

void Display_MinMax()
{
TFT_Set_Font(Tahoma19x19_Bold, CL_WHITE, FO_HORIZONTAL);
InttoStr(x_min, txtrci);
TFT_Write_Text("x_min=", 50, 15);
TFT_Write_Text(txtrci, 115, 15);
InttoStr(x_max, txtrci);
TFT_Write_Text("x_max=", 50, 30);
TFT_Write_Text(txtrci, 115, 30);
InttoStr(y_min, txtrci);
TFT_Write_Text("y_min=", 50, 45);
TFT_Write_Text(txtrci, 115, 45);
InttoStr(y_max, txtrci);
TFT_Write_Text("y_max=", 50, 60);
TFT_Write_Text(txtrci, 115, 60);
}

void Eprom_Store(char numaddr)
{
char low_byte, high_byte;
unsigned int e, count;


count = 0;
 for (e = 0; e < numaddr; e++)
 {
 high_byte = (x_min) >> 8;
 low_byte = (x_min);
 EEPROM_WRITE(count++, high_byte);
 EEPROM_WRITE(count++, low_byte);
 high_byte = (x_max) >> 8;
 low_byte = (x_max);
 EEPROM_WRITE(count++, high_byte);
 EEPROM_WRITE(count++, low_byte);
 high_byte = (y_min) >> 8;
 low_byte = (y_min);
 EEPROM_WRITE(count++, high_byte);
 EEPROM_WRITE(count++, low_byte);
 high_byte = (y_max) >> 8;
 low_byte = (y_max);
 EEPROM_WRITE(count++, high_byte);
 EEPROM_WRITE(count++, low_byte);
 }
 return;
}

void Eprom_Recall(char numaddr)
{
unsigned int e, count, temp;
temp = 0;


count = 0;
 for (e = 0; e < numaddr; e++)
 {
 temp = (EEPROM_READ(count++)) << 8;
 x_min = temp + (EEPROM_READ(count++));
 temp = (EEPROM_READ(count++)) << 8;
 x_max = temp + (EEPROM_READ(count++));
 temp = (EEPROM_READ(count++)) << 8;
 y_min = temp + (EEPROM_READ(count++));
 temp = (EEPROM_READ(count++)) << 8;
 y_max = temp + (EEPROM_READ(count++));
 }
 return;
}
#line 14 "C:/Evil Genius/MikroProC/P18F4685/X10 Color Touch Pen Cal/X10_Color_Touch_main.c"
void Display_X10_TFT();
unsigned int x_coord, y_coord;

void Calibrate()
{
 TFT_Set_Pen(CL_WHITE, 3);
 TFT_Circle(314,5,5);

 Delay_ms(5000);
 TP_TFT_Calibrate_Min();

 TFT_Fill_Screen(CL_OLIVE);
 TFT_Set_Pen(CL_WHITE, 3);
 TFT_Circle(5,234,5);

 Delay_ms(5000);
 TP_TFT_Calibrate_Max();

 TP_TFT_Get_Calibration_Consts(&x_min, &x_max, &y_min, &y_max);
}

void main()
{
 Start_TP();
 Delay_ms(250);
 if (EEPROM_READ(8) == 34) goto skip;
cal:
 TFT_Set_Pen(CL_WHITE, 10);
 TFT_Fill_Screen(CL_RED);
 Calibrate();
 Delay_ms(250);

 if (EEPROM_READ(8) != 34)
 {
 Eprom_Store(8);
 EEPROM_Write(8, 34);
 Delay_ms(50);
 }
skip:
 Eprom_Recall(8);
 Delay_ms(50);
 TFT_Fill_Screen(CL_RED);
 Display_MinMax();
 Delay_ms(5000);
 DrawScreen(&Screen1);

 while (1 == 1)
 {
 Check_TP();
 if (PORTE.F0 == 0)
 {
 EEPROM_Write(8, 0);
 goto cal;
 }
 Display_X10_TFT();
 }

}
