#include "X10_Color_Touch_resources.h"
unsigned int x_min, y_min, x_max, y_max; // Calibration constants
char txtrci[6];
//****************************************************************************
void Display_MinMax()
{
TFT_Set_Font(Tahoma19x19_Bold, CL_WHITE, FO_HORIZONTAL);
InttoStr(x_min, txtrci);
TFT_Write_Text("x_min=", 50, 15);
TFT_Write_Text(txtrci, 115, 15);
InttoStr(x_max, txtrci);
TFT_Write_Text("x_max=", 50, 30);
TFT_Write_Text(txtrci, 115, 30);
InttoStr(y_min, txtrci);
TFT_Write_Text("y_min=", 50, 45);
TFT_Write_Text(txtrci, 115, 45);
InttoStr(y_max, txtrci);
TFT_Write_Text("y_max=", 50, 60);
TFT_Write_Text(txtrci, 115, 60);
}
//***************************************************************************
void Eprom_Store(char numaddr)
{
char low_byte, high_byte;
unsigned int e, count;
//**********************WRITE EEPROM DATA**********
//  Writes all color parameters
count = 0;
    for (e = 0; e < numaddr; e++)
        {
        high_byte = (x_min) >> 8;
        low_byte  = (x_min);
        EEPROM_WRITE(count++, high_byte);
        EEPROM_WRITE(count++, low_byte);
        high_byte = (x_max) >> 8;
        low_byte  = (x_max);
        EEPROM_WRITE(count++, high_byte);
        EEPROM_WRITE(count++, low_byte);
        high_byte = (y_min) >> 8;
        low_byte  = (y_min);
        EEPROM_WRITE(count++, high_byte);
        EEPROM_WRITE(count++, low_byte);
        high_byte = (y_max) >> 8;
        low_byte  = (y_max);
        EEPROM_WRITE(count++, high_byte);
        EEPROM_WRITE(count++, low_byte);
        }
    return;
}
//***************************************************************************
void Eprom_Recall(char numaddr)
{
unsigned int e, count, temp;
temp = 0;
//**********************READ EEPROM DATA**********
//  Recalls all color parameters
count = 0;
    for (e = 0; e < numaddr; e++)
        {
        temp = (EEPROM_READ(count++)) << 8;
        x_min = temp + (EEPROM_READ(count++));
        temp = (EEPROM_READ(count++)) << 8;
        x_max = temp + (EEPROM_READ(count++));
        temp = (EEPROM_READ(count++)) << 8;
        y_min = temp + (EEPROM_READ(count++));
        temp = (EEPROM_READ(count++)) << 8;
        y_max = temp + (EEPROM_READ(count++));
        }
    return;
}
//***************************************************************************