#line 1 "C:/Evil Genius/MikroProC/P18F4685/X10 Color Touch Pen Cal/X10_Color_Touch_events_code.c"
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10_color_touch_objects.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TButton Button1;
extern TButton Button2;
extern TButton Button3;
extern TButton Button4;
extern TButton Button5;
extern TButton Button6;
extern TButton Button7;
extern TButton Button8;
extern TButton Button17;
extern TButton Button18;
extern TButton Button19;
extern TLabel Label5;
extern TLabel Label6;
extern TButton * const code Screen1_Buttons[11];
extern TLabel * const code Screen1_Labels[4];


extern TScreen Screen2;
extern TLabel Label3;
extern TLabel Label4;
extern TButton Button9;
extern TButton Button10;
extern TButton Button11;
extern TButton Button12;
extern TButton Button13;
extern TButton Button14;
extern TButton Button15;
extern TButton Button16;
extern TButton Button24;
extern TButton Button25;
extern TButton Button22;
extern TLabel Label7;
extern TLabel Label8;
extern TButton * const code Screen2_Buttons[11];
extern TLabel * const code Screen2_Labels[4];





void Button1Down();
void Button2Down();
void Button3Down();
void Button4Down();
void Button5Down();
void Button6Down();
void Button7Down();
void Button8Down();
void Button17Down();
void Button18Down();
void Button19Down();
void Button9Down();
void Button10Down();
void Button11Down();
void Button12Down();
void Button13Down();
void Button14Down();
void Button15Down();
void Button16Down();
void Button24Down();
void Button25Down();
void Button22Down();




extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button17_Caption[];
extern char Button18_Caption[];
extern char Button19_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Button16_Caption[];
extern char Button24_Caption[];
extern char Button25_Caption[];
extern char Button22_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10_color_touch_resources.h"
const code char Tahoma18x18_Bold[];
const code char Tahoma16x19_Regular[];
const code char Tahoma19x19_Bold[];
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/delay_sub.h"




void Delay5us()
{
Delay_us(5);
}

void Delay20us()
{
Delay_us(20);
}

void Delay50us()
{
Delay_us(50);
}

void Delay2ms()
{
Delay_ms(2);
}

void Delay5ms()
{
Delay_ms(5);
}

void Delay10ms()
{
Delay_ms(10);
}

void Delay50ms()
{
Delay_ms(50);
}

void Delay100ms()
{
Delay_ms(100);
}

void Delay500ms()
{
Delay_ms(500);
}

void Delay1000ms()
{
Delay_ms(1000);
}

void Delay2000ms()
{
Delay_ms(2000);
}

void Delay3000ms()
{
Delay_ms(3000);
}
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10.h"
#line 28 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10.h"
char const House_Code_Table[17] = {'M','N','O','P','C','D','A','B','E',
 'F','G','H','K','L','I','J'};
char const Key_Code_Table[17] = {13, 14, 15, 16, 3, 4, 1, 2, 5, 6, 7,
 8, 11, 12, 9, 10};
char txt4[4], temp, setbit;
char house_code, key_code;

char shiftRight(char number)
{
 return number >>= 1;
}

char Rcv_Data()
{
 return (! PORTC.F2 );
}

void wait_for_zero_crossing()
{
 if( PORTC.F0 )
 while( PORTC.F0 ) ;
 else
 while(! PORTC.F0 ) ;
}

void x10_write_bits(char datam, char numofbits, char startbit)
{
 char loopcount;

 for(loopcount = 1; loopcount <= numofbits; ++loopcount)
 {
 wait_for_zero_crossing();
 datam = shiftRight(datam);
  PORTC.F1  = datam.F0;
 delay_ms(1);
  PORTC.F1  = 0;
 if(startbit == 0)
 {
 wait_for_zero_crossing();
  PORTC.F1  = !datam.F0;
 delay_ms(1);
  PORTC.F1  = 0;
 }
 }
 return;
}

void x10_write(char house_code2, char key_code2)
{
 char i;
 i = 0;
 while (House_Code_Table[i] != house_code2)
 i++;
 house_code2 = i;
 if(key_code2 < 16)
 {
 i = 0;
 while (Key_Code_Table[i] != key_code2)
 i++;
 key_code2 = i;
 }
 x10_write_bits(7 * 2, 4, 1);
 x10_write_bits(house_code2 * 2, 4, 0);
 x10_write_bits(key_code2 * 2, 5, 0);
 x10_write_bits(0, 6, 1);
 return;
}

char x10_read_bits(char num)
{
char ic, dataval;

 for(ic = 1; ic <= num; ++ic)
 {
 wait_for_zero_crossing();
 delay_us(150);
 if ( PORTC.F2  == 1)
 {
 setbit = 128;
 }
 else
 {
 setbit = 0;
 }
 dataval = dataval + setbit;
 dataval = shiftRight(dataval);
 wait_for_zero_crossing();
 delay_us(150);
 }
 for(ic = 0; ic < 7 - num; ++ic)
 {
 dataval = shiftRight(dataval);
 }
 return(dataval);
}

void x10_read()
{
 x10_read_bits(2);
 house_code = x10_read_bits(4);
 house_code = House_Code_Table[house_code];
 key_code = x10_read_bits(5);
 if(key_code < 16)
 key_code = Key_Code_Table[key_code];
}

void x10Trans(char House, char Chan, char OnOff)
{
 x10_write(House, Chan);
 x10_write(House, Chan);
 Delay_ms(1000);
 x10_write(House, OnOff);
 x10_write(House, OnOff);
}

void Display_X10(char row, char HousePos, char ChanPos, char StatusPos)
{
 if(Rcv_Data())
 {
 x10_read();

 if (key_code < 19)
 {
 temp = key_code;
 }

 LCD_Chr(row, HousePos, house_code);
 BytetoStr(temp, txt4);
 LCD_Out(row, ChanPos, txt4);
 if (key_code == 20) LCD_Out(row, StatusPos, "ON ");
 if (key_code == 28) LCD_Out(row, StatusPos, "OFF");
 Delay_ms(1000);
 }
}

void Display_X10_TFT()
{
 TFT_Set_Font(Tahoma19x19_Bold, CL_WHITE, FO_HORIZONTAL);
 if(Rcv_Data())
 {
 x10_read();

 if (key_code < 19)
 {
 temp = key_code;
 }
 TFT_Set_Pen(CL_BLACK, 1);

 TFT_Set_Brush(1, CL_BLACK, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);

 TFT_Rectangle(20, 220, 140, 240);



 TFT_Write_Char(house_code, 20, 220);
 BytetoStr(temp, txt4);
 TFT_Write_Text(txt4, 50, 220);
 if (key_code == 20) TFT_Write_Text("ON ", 90, 220);
 if (key_code == 28) TFT_Write_Text("OFF", 90, 220);
 Delay_ms(1000);
 }
}
#line 8 "C:/Evil Genius/MikroProC/P18F4685/X10 Color Touch Pen Cal/X10_Color_Touch_events_code.c"
char House, Chan, OnOff;


void ClearLabel1()
{
Label5.Caption = "   ";
DrawLabel(&Label5);
Label7.Caption = "   ";
DrawLabel(&Label7);
return;
}

void Button1Down() {
Chan = 1;

Label5.Caption = "1";
DrawScreen(&Screen1);
}

void Button2Down() {
Chan = 2;

Label5.Caption = "2";
DrawScreen(&Screen1);
}

void Button3Down() {
Chan = 3;

Label5.Caption = "3";
DrawScreen(&Screen1);
}

void Button4Down() {
Chan = 4;

Label5.Caption = "4";
DrawScreen(&Screen1);
}

void Button5Down() {
Chan = 5;

Label5.Caption = "5";
DrawScreen(&Screen1);
}

void Button6Down() {
Chan = 6;

Label5.Caption = "6";
DrawScreen(&Screen1);
}

void Button7Down() {
Chan = 7;

Label5.Caption = "7";
DrawScreen(&Screen1);
}

void Button8Down() {
Chan = 8;

Label5.Caption = "8";
DrawScreen(&Screen1);
}

void Button9Down() {
Chan = 9;

Label7.Caption = "9 ";
DrawScreen(&Screen2);
}

void Button10Down() {
Chan = 10;

Label7.Caption = "10";
DrawScreen(&Screen2);
}

void Button11Down() {
Chan = 11;

Label7.Caption = "11";
DrawScreen(&Screen2);
}

void Button12Down() {
Chan = 12;

Label7.Caption = "12";
DrawScreen(&Screen2);
}

void Button13Down() {
Chan = 13;

Label7.Caption = "13";
DrawScreen(&Screen2);
}

void Button14Down() {
Chan = 14;

Label7.Caption = "14";
DrawScreen(&Screen2);
}

void Button15Down() {
Chan = 15;

Label7.Caption = "15";
chan = 15;
DrawScreen(&Screen2);
}

void Button16Down() {
Chan = 16;

Label7.Caption = "16";
DrawScreen(&Screen2);
}

void Button17Down()
{
House = 'A';
OnOff = 20;
Label6.Caption = "ON";
DrawScreen(&Screen1);
x10Trans(House, Chan, OnOff);
}

void Button18Down()
{
House = 'A';
OnOff = 28;
Label6.Caption = "OFF";
DrawScreen(&Screen1);
x10Trans(House, Chan, OnOff);
}


void Button24Down()
{
House = 'A';
OnOff = 20;
Label8.Caption = "ON";
DrawScreen(&Screen2);
x10Trans(House, Chan, OnOff);
}

void Button25Down()
{
House = 'A';
OnOff = 28;
Label8.Caption = "OFF";
DrawScreen(&Screen2);
x10Trans(House, Chan, OnOff);
}
